#!/bin/sh
export PROJECT_ROOT=`pwd`
export CAFEE_ROOT=${CAFFE_ROOT:=/home/testuser/caffe/}
export PYTHONPATH=$CAFFE_ROOT/python/
export LD_LIBRARY_PATH=$CAFFE_ROOT/build/lib:$LD_LIBRARY_PATH


# Cleanup old stuff
rm -r *db
rm ./tmp/*

# Create text file with training data
find ./train -name "*.jpg" | tee ./tmp/images | cut -d"/" -f3 > ./tmp/images2
cat ./tmp/images | cut -d"/" -f3,4 > ./tmp/images3
paste -d " " ./tmp/images3 ./tmp/images2 > imagesAll
cp imagesAll ./data/train.txt

# Create text tile with validation data
find ./val -name "*.jpg" | tee ./tmp/images | cut -d"/" -f3 > ./tmp/images2
cat ./tmp/images | cut -d"/" -f3,4 > ./tmp/images3
paste -d " " ./tmp/images3 ./tmp/images2 > imagesAll
cp imagesAll ./data/val.txt

# Create text tile with validation data 2
find ./val2 -name "*.jpg" | tee ./tmp/images | cut -d"/" -f3 > ./tmp/images2
cat ./tmp/images | cut -d"/" -f3,4 > ./tmp/images3
paste -d " " ./tmp/images3 ./tmp/images2 > imagesAll
cp imagesAll ./data/val2.txt

# Create label file for classes
rm ./data/synset_words.txt
touch ./data/synset_words.txt
num=`find ./train -type d | wc -l`
numbers=`echo $num-2 | bc`
for i in `eval echo {0..$numbers}`; do echo $i >> ./data/synset_words.txt; done

# Replace hard coded paths on model and deploy files
# and set the number of output neurons with the count of folders
# from training dataset
numbers=`echo $num-1 | bc`
sed "s|net:.*|net: \"$PROJECT_ROOT/models/train_val.prototxt\"|g" models/solver.prototxt > ./tmp/solver.prototxt
sed "s|snapshot_prefix:.*|snapshot_prefix: \"$PROJECT_ROOT/caffenet_train\"|g" ./tmp/solver.prototxt > models/solver.prototxt
sed "s|mean_file:.*|mean_file: \"$PROJECT_ROOT/data/mean_image.binaryproto\"|g" models/train_val.prototxt > ./tmp/train_val.prototxt

sed "s|num_output:.*#outputlayer.*|num_output: $numbers #outputlayer|g" ./tmp/train_val.prototxt > ./tmp/train_val2.prototxt
sed "s|source:.*val_lmdb.*|source: \"$PROJECT_ROOT/val_lmdb\"|g" ./tmp/train_val2.prototxt > ./tmp/train_val3.prototxt
sed "s|source:.*train_lmdb.*|source: \"$PROJECT_ROOT/train_lmdb\"|g" ./tmp/train_val3.prototxt > models/train_val.prototxt

sed "s|num_output:.*#outputlayer.*|num_output: $numbers #outputlayer|g" ./models/deploy.prototxt > ./tmp/deploy.prototxt
mv ./tmp/deploy.prototxt ./models/deploy.prototxt

sh create_image_database.sh
sh make_mean_image.sh 
