bool loggingEnabled = true;

void debug(const char *text)
{
	#ifdef ANDROID_VERSION
	if (loggingEnabled)	
		__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "%s", text);	
	#else
	if (loggingEnabled)
		std::cout << text << std::endl;	
	#endif
}

void debugSS(const char *text, const char *text2)
{
	#ifdef ANDROID_VERSION
	if (loggingEnabled)	
		__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "%s %s", text, text2);
	#else
	if (loggingEnabled)
		std::cout << text << " " << text2 << std::endl;	
	#endif
}

void debugSI(const char *text, int i)
{
	#ifdef ANDROID_VERSION
	if (loggingEnabled)	
		__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "%s %i", text, i);
	#else
	if (loggingEnabled)
		std::cout << text << " " << i << std::endl;	
	#endif
}

void debugSII(const char *text, int i, int i2)
{
	#ifdef ANDROID_VERSION
	if (loggingEnabled)	
		__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "%s %i %i", text, i, i2);
	#else
	if (loggingEnabled)
		std::cout << text << " " << i << " "<< i2 << std::endl;	
	#endif
}

void error(const char *text)
{
	#ifdef ANDROID_VERSION
		if (loggingEnabled)	
			__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "%s", text);	
	#else	
		if (loggingEnabled)
			std::cerr << text << std::endl;
	throw std::runtime_error(text);
	#endif
}

void errorSS(const char *text1,const char *text2)
{
	#ifdef ANDROID_VERSION
		if (loggingEnabled)	
			__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "%s %s", text1, text2);	
	#else	
		if (loggingEnabled)
			std::cerr << text1 << " " << text2 << std::endl;
	throw std::runtime_error(text1);
	#endif
}


void errorSI(const char *text1, int i)
{
	#ifdef ANDROID_VERSION
		if (loggingEnabled)	
			__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "%s %i", text1, i);	
	#else	
		if (loggingEnabled)
			std::cerr << text1 << " " << i << std::endl;
	throw std::runtime_error(text1);
	#endif
}
