package openCvFaces.utils;

import org.opencv.core.Core;
import org.opencv.core.CvType;
import org.opencv.core.Mat;
import org.opencv.imgproc.Imgproc;

public class ConvertImages implements ConvertImage
{
	private int dim = 128;
	
	private Mat tmp;
	
	public ConvertImages()
	{
		System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
		tmp = new Mat(dim,dim,CvType.CV_8UC3);
	}

	public Mat convetImage(Mat image)
	{
		
		Imgproc.resize(image,             // input image 
			       tmp,            		  // result image
			       tmp.size(),            // new dimensions
			       0, 
			       0, 
			       Imgproc.INTER_CUBIC       // interpolation method
			      );
		
		return tmp;
	}

}
