package openCvFaces.utils;

import java.io.File;
import java.io.InputStream;

import org.opencv.core.Core;
import org.opencv.core.Mat;
import org.opencv.highgui.Highgui;
import org.opencv.core.Size;
import org.opencv.core.Point;
import org.opencv.core.Scalar;
import org.opencv.imgproc.Imgproc;
import org.opencv.core.CvType;
import java.util.Random;
import java.util.ArrayList;

public class OpenFiles implements OpenFile
{
	private SearchFile sf;
	private InputStream is;
	private String path;
	private Random randomGenerator;
	private boolean noRotate = true;
	
	public OpenFiles(SearchFile files)
	{
		randomGenerator = new Random();
		System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
		setfiles(files);
	}

	public void setfiles(SearchFile files)
	{
		sf = files;
		
	}

	public Mat getFile()
	{
		path = sf.getFile();
		
		if(path == null)
			return null;
		
		return Highgui.imread(path); 
	}
	
	public ArrayList<Mat> getFileRandomRotates()
	{
		ArrayList<Mat> lst = new ArrayList<Mat>();
		path = sf.getFile();
		
		if(path == null)
			return null;

		Mat m = Highgui.imread(path); 
		
		if (noRotate)
		{
				lst.add(m);			
		}
		else
		{
			for (int times = 0; times < 4; times++)
			{
				Mat m2 = new Mat(m.rows(),m.cols(), CvType.CV_8UC3);
				//int len = m.cols();
				//if  (len < m.rows());
				//	len = m.rows();
			
				double angle = (randomGenerator.nextInt(1000)-randomGenerator.nextInt(1000) )/100.0f;
				Point pt = new Point((m.cols())/2.0f, (m.rows())/2.0f);
				Mat r = Imgproc.getRotationMatrix2D(pt, angle, 0.85 + randomGenerator.nextInt(1000)/1000.0f * 0.1);
				
				Imgproc.warpAffine(m, m2, r, new Size(m2.cols(), m2.rows()), Imgproc.INTER_LINEAR, Imgproc.BORDER_REFLECT, new Scalar(0.0));
														
				r.release();
				//Highgui.imwrite("/home/benutzer/tmp.jpg",m2);
				lst.add(m2);
			}
			m.release();
		}
		return lst;	
	}	
	
	public String getFileName()
	{
		return sf.getFolder();
	}
}
